from endstone.plugin import Plugin
from endstone.command import Command, CommandSender
from endstone import ColorFormat
from endstone.form import ActionForm, ModalForm, TextInput
from endstone.event import event_handler, PlayerInteractEvent
from endstone import ColorFormat
import os
import json
import math
import numpy as np
import ast
# 获取当前插件的运行目录
current_dir = os.getcwd()
#global runmode,coordinate_list,current_player,block_id,opencount,player_namea,runmode_load,runmode_save,blockposx,blockposy,blockposz
# 全局变量
fail=0
success=0
generate_commands_list=[]
filesender=""
filemode=0
fileindex=0
listlen=0
index=0
blockposx=0
blockposy=0
blockposz=0
runmode = 0
coordinate_list = []
current_player = None
block_id = None  # 添加全局变量保存 block_id
opencount = 0  # 用于控制事件触发次数
player_namea = ""  # 保存当前执行命令的玩家名字
runmode_save=0
runmode_load=0
playerx=0
playery=0
playerz=0
sendername=""
blockid=""
pointmode=0
points=[]
reminx=0
reminy=0
reminz=0
remaxx=0
remaxy=0
remaxz=0
remode=0
tpcmd=""
fillcmd=""
replayername=""
def load_config():
    # 获取当前脚本的运行目录
    plugin_dir = os.path.join(os.getcwd(), 'plugins', 'worldbuilder')
    
    # 定义 config.json 文件的路径
    config_path = os.path.join(plugin_dir, 'config.json')
    
    # 默认配置内容
    default_config = {
        "period": 2,
        "commandname": "worldeditor",
        "aliases": ["we", "ca", "call"],
        "load_file_speed":16
    }
    
    # 如果插件目录不存在，创建目录
    if not os.path.exists(plugin_dir):
        os.makedirs(plugin_dir)
    
    # 如果 config.json 文件不存在，创建并写入默认配置
    if not os.path.exists(config_path):
        with open(config_path, 'w') as config_file:
            json.dump(default_config, config_file, indent=4)
        
    
    
    # 读取 config.json 文件内容
    with open(config_path, 'r') as config_file:
        config = json.load(config_file)
    if "load_file_speed" not in config:
        config["load_file_speed"] = 16  # 添加默认值
        
        # 更新配置文件
        with open(config_path, 'w') as config_file:
            json.dump(config, config_file, indent=4)
    return config
def generate_commands(x, y, z, block_list):
    commands = []
    
    # 遍历 z 层 (外层列表)
    for z_offset, row in enumerate(block_list):
        # 如果 z_offset 是偶数行，按正常顺序遍历
        if z_offset % 2 == 0:
            for x_offset, block in enumerate(row):
                commands.append(f"tp @s {x + x_offset} {y} {z + z_offset}")
                commands.append(f"setblock {x + x_offset} {y} {z + z_offset} {block}")
        # 如果 z_offset 是奇数行，按逆序遍历
        else:
            for x_offset, block in enumerate(reversed(row)):
                actual_x_offset = len(row) - 1 - x_offset  # 计算实际的 x 坐标
                commands.append(f"tp @s {x + actual_x_offset} {y} {z + z_offset}")
                commands.append(f"setblock {x + actual_x_offset} {y} {z + z_offset} {block}")
    
    return commands


def txt_to_list(fileplace):
    try:
        with open(fileplace, 'r', encoding='utf-8') as file:
            # 读取文件的整行数据
            data_string = file.read().strip()
            # 使用 ast.literal_eval 安全地解析字符串形式的 Python 字面量
            data_list = ast.literal_eval(data_string)
            return data_list
    except FileNotFoundError:
        print("文件未找到:", fileplace)
        return []
    except SyntaxError as e:
        print("文件内容解析错误，检查是否符合Python字面量格式:", e)
        return []
    except Exception as e:
        print("解析过程中出现意外错误:", e)
        return []
class Ye111566Worldbuilder(Plugin):
    api_version = "0.5"
    def refill(self) -> None:
        global reminx,reminy,reminz,remaxx,remaxy,remaxz,tpcmd,fillcmd,replayername,remode
        if remode==1:
            current_player=self.server.get_player(replayername)
            current_player.send_error_message(f"填充失败!x={reminx}~{remaxx}, z={reminz}~{remaxz},正在重试")
            current_player.perform_command(tpcmd)
            ta = f"tickingarea add {reminx} {reminy} {reminz} {remaxx} {remaxy} {remaxz} worldbuilder true"
            current_player.perform_command(ta)
            out=current_player.perform_command(fillcmd)
            current_player.perform_command("tickingarea remove worldbuilder")
            if out ==True:
                current_player.send_message(f"§a恭喜你，重试填充成功！x={reminx}~{remaxx}, z={reminz}~{remaxz}")
            if out ==False:
                current_player.send_error_message(f"重试填充失败！x={reminx}~{remaxx}, z={reminz}~{remaxz},放弃重试,请延长/plugins/worldbuilder/config.json中的period的周期！(如果是填充了一样的方块可忽略)")
            remode=0
    def on_enable(self) -> None:
        self.register_events(self)
        load_config()
        periodset = load_config()['period']
        self.server.scheduler.run_task(self, self.send_time, period=periodset)  # 定时任务执行函数
        self.server.scheduler.run_task(self, self.send_time_a, period=5)  # 定时检查计数器
        self.server.scheduler.run_task(self, self.send_time_save, period=periodset)
        self.server.scheduler.run_task(self, self.send_time_load, period=periodset)
        self.server.scheduler.run_task(self, self.send_time_point, period=periodset)
        self.server.scheduler.run_task(self, self.send_time_file, period=periodset)
        # 加载或创建配置文件
        self.pos_file = os.path.join(current_dir, "plugins", "worldbuilder", "pos.json")
        if not os.path.exists(self.pos_file):
            os.makedirs(os.path.dirname(self.pos_file), exist_ok=True)
            with open(self.pos_file, 'w', encoding='utf-8') as f:
                json.dump({}, f, ensure_ascii=False, indent=4)
    config = load_config()

    # 使用配置内容
    period = config['period']
    command_name = config['commandname']
    aliases = config['aliases']

    

    commands = {
        f"{command_name}": {
            "description": "快速建筑",
            "usages": [f"/{command_name} (posa|posb|fill|save|load|re)[name: EnumType] [id:block]",
                       f"/{command_name} (posaas|posbas)[name: EnumType] [x:int] [y:int] [z:int]",
                       f"/{command_name} (spheroid)[name: EnumType] [x:int] [y:int] [z:int] [rx:int] [ry:int] [rz:int] [id:block]",
                       f"/{command_name} (file)[name: EnumType] [filename:str]"],
            "permissions": ["ye111566_worldbuilder.command.worldbuilder"],
            "aliases": aliases
        }
    }

    permissions = {
        "ye111566_worldbuilder.command.worldbuilder": {
            "description": "§b§l§o快速建筑",
            "default": True,
        }
    }








    
    def generate_ellipsoid_points(self, center_x, center_y, center_z, radius_x, radius_y, radius_z):
        # 椭球体的包围盒
        x_min, x_max = int(center_x - radius_x), int(center_x + radius_x)
        y_min, y_max = int(center_y - radius_y), int(center_y + radius_y)
        z_min, z_max = int(center_z - radius_z), int(center_z + radius_z)

        # 生成所有可能的坐标点（在包围盒内）
        x = np.arange(x_min, x_max + 1)
        y = np.arange(y_min, y_max + 1)
        z = np.arange(z_min, z_max + 1)

        # 使用 meshgrid 创建 3D 坐标网格
        X, Y, Z = np.meshgrid(x, y, z, indexing='ij')

        # 椭球方程：((x - center_x) / radius_x)^2 + ((y - center_y) / radius_y)^2 + ((z - center_z) / radius_z)^2 <= 1
        ellipsoid_mask = ((X - center_x) / radius_x) ** 2 + \
                        ((Y - center_y) / radius_y) ** 2 + \
                        ((Z - center_z) / radius_z) ** 2 <= 1

        # 获取符合条件的点
        ellipsoid_points = np.column_stack((X[ellipsoid_mask], Y[ellipsoid_mask], Z[ellipsoid_mask]))

        return ellipsoid_points.tolist()

    





    """def send_time_file_slow(self):
        global filemode,fileindex,generate_commands_list,filesender
        sender=self.server.get_player(filesender)
        tasklist=generate_commands_list
        if filemode==1:
            success=0
            fail=0
            if fileindex<len(tasklist):
                sender.send_message(tasklist[fileindex])
                out=self.server.get_player(sender.name).perform_command(tasklist[fileindex])
                if out==True:
                    success=success+1
                if out==False:
                    fail=fail+1
                fileindex=fileindex+1
            else:
            # 如果任务列表遍历完成，重置filemode和fileindex，或者做其他处理
                sender.send_message(f"Task list completed.fail:{fail},success:{success}")
                filemode = 0  # 停止任务执行
                fileindex = 0 
                generate_commands_list=[]
                filesender=''"""



    def send_time_file(self):
        global filemode, fileindex, generate_commands_list, filesender,fail,success
        sender = self.server.get_player(filesender)
        tasklist = generate_commands_list
        speed=load_config()["load_file_speed"]

        # 每次被执行时，如果 filemode 为 1
        if filemode == 1:
            # 计算剩余未执行的任务数量
            remaining_tasks = len(tasklist) - fileindex

            # 计算要执行的任务数量，最大为 16
            tasks_to_execute = min(speed, remaining_tasks)

            # 循环执行这次需要处理的 16 个任务
            for i in range(tasks_to_execute):
                if fileindex < len(tasklist):
                    # 发送任务消息给玩家并执行命令
                    sender.send_message(tasklist[fileindex])
                    out = self.server.get_player(sender.name).perform_command(tasklist[fileindex])
                    
                    if out:
                        success += 1
                    else:
                        
                        sender.send_error_message(f"执行失败:{tasklist[fileindex]}")
                        sender.perform_command("tickingarea add ~~~~~~ worldbuilder true")
                        outout=self.server.get_player(sender.name).perform_command(tasklist[fileindex])
                        if outout:
                            success +=1
                            sender.send_message(f"§l§a第二次执行成功:{tasklist[fileindex]}")
                        else:
                            sender.send_error_message(f"第二次执行失败，已放弃:{tasklist[fileindex]}")
                            fail +=1
                        sender.perform_command("tickingarea remove worldbuilder")
                    # 更新索引，指向下一个任务
                    fileindex += 1

            # 如果所有任务执行完毕
            if fileindex >= len(tasklist):
                # 发送任务完成的消息，并报告成功和失败的数量
                sender.send_message(f"Task list completed. Failures: {fail}, Successes: {success}")
                # 重置状态
                fail=0
                success=0
                filemode = 0  # 停止任务执行
                fileindex = 0  # 重置索引
                generate_commands_list = []  # 清空任务列表
                filesender = ""  # 重置发送者






    def on_command(self, sender: CommandSender, command: Command, args: list[str]) -> bool:
        try:
            global block_id, runmode, runmode_save, runmode_load,playerx,playery,playerz,ox,oy,oz
            posax=self.load_pos_data()[sender.name]["posa"]["x"]
            posay=self.load_pos_data()[sender.name]["posa"]["y"]
            posaz=self.load_pos_data()[sender.name]["posa"]["z"]
            posbx=self.load_pos_data()[sender.name]["posb"]["x"]
            posby=self.load_pos_data()[sender.name]["posb"]["y"]
            posbz=self.load_pos_data()[sender.name]["posb"]["z"]
            
            playerx=math.floor(self.server.get_player(sender.name).location.x)-min(posax,posbx)
            playery=math.floor(self.server.get_player(sender.name).location.y)-min(posay,posby)
            playerz=math.floor(self.server.get_player(sender.name).location.z)-min(posaz,posbz)
            ox=math.floor(self.server.get_player(sender.name).location.x)
            oy=math.floor(self.server.get_player(sender.name).location.y)
            oz=math.floor(self.server.get_player(sender.name).location.z)
        except KeyError as e:
            sender.send_message("你的小木斧暂未选区，这将影响fill save load re这些功能")
            sender.send_message("如果你是使用file和spheroid功能，可以忽略本消息")
        if command.name == load_config()['commandname']:
            if args[0] == "file" and len(args) >=2:
                fileplace=os.path.join(os.getcwd(), 'plugins', 'worldbuilder' ,"import" ,f"{args[1]}")
                sender.send_message(fileplace)
                filex=sender.location.x
                filey=sender.location.y
                filez=sender.location.z
                sender.send_message(f"{fileplace},{filex},{filey},{filez}")
                global generate_commands_list,filesender
                filesender=sender.name#########
                generate_commands_list=generate_commands(filex,filey,filez,txt_to_list(fileplace))
                sender.send_message(str(len(generate_commands_list)))
                global filemode
                filemode=1
                
                
            """if len(args) >= 1:
                if args[0] == "fill":
                    if len(args) >= 2:
                        block_id = args[1]
                        self.fill_area(sender, block_id)
                elif args[0] == "save":
                    if len(args) >= 2:
                        structure_name = args[1]
                        self.save_structure(sender, structure_name)
                elif args[0] == "load":
                    if len(args) >= 2:
                        structure_name = args[1]
                        self.load_structure(sender, structure_name)"""
            if args[0]=="fill":
                block_id=args[1]
                self.fill_area(sender,block_id)
            if args[0]=="save":
                structure_name = "worldbuilder"
                self.save_structure(sender, structure_name)
            if args[0]=="load":
                structure_name = "worldbuilder"
                self.load_structure(sender, structure_name)
            if args[0]=="re":
                structure_name = "worldbuilder"
                playerx=0
                playery=0
                playerz=0
                self.load_structure(sender, structure_name)
            if args[0]=="posa":
                pos_data = self.load_pos_data()
                pos_data[sender.name]["dim"] = self.get_dimension_code(sender.location.dimension.name)
                pos_data[sender.name]["count"] = 0
                sender.send_message(f"PosA 已保存为: x={sender.location.x}, y={sender.location.y}, z={sender.location.z}")
                
                pos_data[sender.name]["posa"]["x"] = int(sender.location.x)
                pos_data[sender.name]["posa"]["y"] = int(sender.location.y)
                pos_data[sender.name]["posa"]["z"] = int(sender.location.z)
                self.save_pos_data(pos_data)
            if args[0]=="posb":
                pos_data = self.load_pos_data()
                pos_data[sender.name]["dim"] = self.get_dimension_code(sender.location.dimension.name)
                pos_data[sender.name]["count"] = 1
                sender.send_message(f"PosB 已保存为: x={sender.location.x}, y={sender.location.y}, z={sender.location.z}")
                
                pos_data[sender.name]["posb"]["x"] = int(sender.location.x)
                pos_data[sender.name]["posb"]["y"] = int(sender.location.y)
                pos_data[sender.name]["posb"]["z"] = int(sender.location.z)
                self.save_pos_data(pos_data)
                sender.send_message(f"开始自动转换posa为小 posb为大")
                posaxn=self.load_pos_data()[sender.name]["posa"]["x"]
                posayn=self.load_pos_data()[sender.name]["posa"]["y"]
                posazn=self.load_pos_data()[sender.name]["posa"]["z"]
                posbxn=self.load_pos_data()[sender.name]["posb"]["x"]
                posbyn=self.load_pos_data()[sender.name]["posb"]["y"]
                posbzn=self.load_pos_data()[sender.name]["posb"]["z"]
                pos_data[sender.name]["posa"] = {
                    "x": int(min(posaxn,posbxn)),
                    "y": int(min(posayn,posbyn)),
                    "z": int(min(posazn,posbzn))
                }#######
                pos_data[sender.name]["posb"] = {
                    "x": int(max(posaxn,posbxn)),
                    "y": int(max(posayn,posbyn)),
                    "z": int(max(posazn,posbzn))
                }
                self.save_pos_data(pos_data)
                posaxe=self.load_pos_data()[sender.name]["posa"]["x"]
                posaye=self.load_pos_data()[sender.name]["posa"]["y"]
                posaze=self.load_pos_data()[sender.name]["posa"]["z"]
                posbxe=self.load_pos_data()[sender.name]["posb"]["x"]
                posbye=self.load_pos_data()[sender.name]["posb"]["y"]
                posbze=self.load_pos_data()[sender.name]["posb"]["z"]
                sender.send_message(f"posa:({posaxe},{posaye},{posaze}) posb:({int(posbxe)},{int(posbye)},{int(posbze)})")
                self.save_pos_data(pos_data)
            if args[0] == "posaas":
                pos_data = self.load_pos_data()
                pos_data.setdefault(sender.name, {"posa": {}, "posb": {}, "dim": None, "count": 0})
                
                pos_data[sender.name]["dim"] = self.get_dimension_code(sender.location.dimension.name)
                pos_data[sender.name]["count"] = 0

                try:
                    x = int(args[1])
                    y = int(args[2])
                    z = int(args[3])
                except ValueError:
                    sender.send_message("坐标必须是有效的整数!")
                    return False

                pos_data[sender.name]["posa"]["x"] = x
                pos_data[sender.name]["posa"]["y"] = y
                pos_data[sender.name]["posa"]["z"] = z
                self.save_pos_data(pos_data)
                sender.send_message(f"PosA 已保存为: x={x}, y={y}, z={z}")

            if args[0] == "posbas":
                pos_data = self.load_pos_data()
                pos_data.setdefault(sender.name, {"posa": {}, "posb": {}, "dim": None, "count": 0})

                pos_data[sender.name]["dim"] = self.get_dimension_code(sender.location.dimension.name)
                pos_data[sender.name]["count"] = 1

                try:
                    x = int(args[1])
                    y = int(args[2])
                    z = int(args[3])
                except ValueError:
                    sender.send_message("坐标必须是有效的整数!")
                    return False

                pos_data[sender.name]["posb"]["x"] = x
                pos_data[sender.name]["posb"]["y"] = y
                pos_data[sender.name]["posb"]["z"] = z
                self.save_pos_data(pos_data)
                sender.send_message(f"PosB 已保存为: x={x}, y={y}, z={z}")

                # 这里开始调整 posa 和 posb
                sender.send_message(f"开始自动转换posa为小 posb为大")

                posaxn = pos_data[sender.name]["posa"]["x"]
                posayn = pos_data[sender.name]["posa"]["y"]
                posazn = pos_data[sender.name]["posa"]["z"]
                posbxn = pos_data[sender.name]["posb"]["x"]
                posbyn = pos_data[sender.name]["posb"]["y"]
                posbzn = pos_data[sender.name]["posb"]["z"]

                pos_data[sender.name]["posa"] = {
                    "x": int(min(posaxn, posbxn)),
                    "y": int(min(posayn, posbyn)),
                    "z": int(min(posazn, posbzn))
                }
                
                pos_data[sender.name]["posb"] = {
                    "x": int(max(posaxn, posbxn)),
                    "y": int(max(posayn, posbyn)),  # 修正错误
                    "z": int(max(posazn, posbzn))   # 修正错误
                }
                self.save_pos_data(pos_data)

                # 发送结果
                sender.send_message(f"posa:({pos_data[sender.name]['posa']['x']}, {pos_data[sender.name]['posa']['y']}, {pos_data[sender.name]['posa']['z']})")
                sender.send_message(f"posb:({pos_data[sender.name]['posb']['x']}, {pos_data[sender.name]['posb']['y']}, {pos_data[sender.name]['posb']['z']})")




            
            if len(args) >= 8 and args[0] == "spheroid":
                global blockid
                center_x=int(args[1])
                center_y=int(args[2])
                center_z=int(args[3])
                rx=int(args[4])
                ry=int(args[5])
                rz=int(args[6])
                blockid=args[7]
                global sendername
                sendername=sender.name
                
                global points
                points=self.generate_ellipsoid_points(center_x,center_y,center_z,rx,ry,rz)
                global listlen
                listlen=len(points)
                global pointmode
                pointmode=1
                
            
        return True



    def save_structure(self, sender: CommandSender, structure_name: str):
        global runmode_save, coordinate_list, current_player

        player_name = sender.name
        pos_data = self.load_pos_data()

        if player_name not in pos_data:
            sender.send_message("请先设置 posa 和 posb 位置！")
            return

        posa = pos_data[player_name]["posa"]
        posb = pos_data[player_name]["posb"]
        dim = pos_data[player_name]["dim"]

        # 计算选区大小
        min_x = min(posa["x"], posb["x"])
        max_x = max(posa["x"], posb["x"])
        min_y = min(posa["y"], posb["y"])
        max_y = max(posa["y"], posb["y"])
        min_z = min(posa["z"], posb["z"])
        max_z = max(posa["z"], posb["z"])

        # 划分小选区
        coordinate_list = []
        for x in range(min_x, max_x + 1, 16):
            for z in range(min_z, max_z + 1, 16):
                coordinate_list.append((x, min_y, z, min(x + 15, max_x), max_y, min(z + 15, max_z)))

        current_player = sender
        runmode_save = 1
        sender.send_message(f"开始保存结构，共 {len(coordinate_list)} 个小选区！")

    def load_structure(self, sender: CommandSender, structure_name: str):
        global runmode_load, coordinate_list, current_player

        player_name = sender.name
        pos_data = self.load_pos_data()

        if player_name not in pos_data:
            sender.send_message("请先设置 posa 和 posb 位置！")
            return

        posa = pos_data[player_name]["posa"]
        posb = pos_data[player_name]["posb"]
        dim = pos_data[player_name]["dim"]

        # 计算选区大小
        min_x = min(posa["x"], posb["x"])
        max_x = max(posa["x"], posb["x"])
        min_y = min(posa["y"], posb["y"])
        max_y = max(posa["y"], posb["y"])
        min_z = min(posa["z"], posb["z"])
        max_z = max(posa["z"], posb["z"])

        # 划分小选区
        coordinate_list = []
        for x in range(min_x, max_x + 1, 16):
            for z in range(min_z, max_z + 1, 16):
                coordinate_list.append((x, min_y, z, min(x + 15, max_x), max_y, min(z + 15, max_z)))

        current_player = sender
        runmode_load = 1
        sender.send_message(f"开始加载结构，共 {len(coordinate_list)} 个小选区！")
    def send_time_point(self) -> None:
        global index
        global listlen
        global points
        global sendername
        global blockid
        global pointmode
        global ox,oy,oz
        
        # 当 pointmode 为 1 时，执行遍历
        if pointmode == 1:
            sender=self.server.get_player(sendername)
            # 确保索引未超出列表长度
            if index < listlen:
                # 输出当前 points 列表中的元素或进行你需要的操作
                point=points[index] # 或者其他操作
                x, y, z = point
                command_to_execute = f"setblock {int(x)} {int(y)} {int(z)} {blockid}"
                sender.send_message(command_to_execute)
                self.server.get_player(sender.name).perform_command(f"tp @s {int(x)} {int(y)} {int(z)}")
                self.server.get_player(sender.name).perform_command(command_to_execute)
                # 增加索引
                index += 1

                # 递归调用自身进行下一个元素的处理
                
            else:
                # 当遍历完成后，重置 index 和 pointmode
                index = 0
                pointmode = 0
                sender.send_message(f"椭球体生成成功！")
                self.server.get_player(sender.name).perform_command(f"tp @s {ox} {oy} {oz}")
            

    def send_time_save(self) -> None:
        global runmode_save, coordinate_list, current_player

        if runmode_save == 1 and current_player is not None:
            if coordinate_list:
                coord = coordinate_list.pop(0)
                min_x, min_y, min_z, max_x, max_y, max_z = coord

                tp_command = f"execute in {self.get_dimension_name()} run tp @s {min_x} ~ {min_z}"
                save_command = f"structure save worldbuilder_{min_x}_{min_z} {min_x} {min_y} {min_z} {max_x} {max_y} {max_z}"
                current_player.send_message(f"{save_command}")
                current_player.perform_command(tp_command)
                current_player.perform_command(save_command)

                current_player.send_message(f"已保存小选区: x={min_x}~{max_x}, z={min_z}~{max_z}")
            else:
                current_player.send_message("结构保存完成！")
                global ox,oy,oz
                current_player.perform_command(f"tp @s {ox} {oy} {oz}")
                runmode_save = 0




    def send_time_load(self) -> None:
        global runmode_load, coordinate_list, current_player,playerx,playery,playerz

        if runmode_load == 1 and current_player is not None:
            if coordinate_list:
                coord = coordinate_list.pop(0)
                min_x, min_y, min_z, max_x, max_y, max_z = coord

                tp_command = f"execute in {self.get_dimension_name()} run tp @s {playerx+min_x} ~ {playerz+min_z}"
                load_command = f"structure load worldbuilder_{min_x}_{min_z} {playerx+min_x} {playery+min(min_y, max_y)} {playerz+min_z}"
                current_player.send_message(f"{load_command}")
                current_player.perform_command(tp_command)
                current_player.perform_command(load_command)

                current_player.send_message(f"已加载小选区: x={min_x}~{max_x}, z={min_z}~{max_z}")
            else:
                current_player.send_message("结构加载完成！")
                global ox,oy,oz
                current_player.perform_command(f"tp @s {ox} {oy} {oz}")
                runmode_load = 0



    # 读取 pos.json 文件数据
    def load_pos_data(self):
        if os.path.exists(self.pos_file):
            with open(self.pos_file, 'r', encoding='utf-8') as f:
                return json.load(f)
        return {}

    # 保存 pos.json 文件数据
    def save_pos_data(self, pos_data):
        with open(self.pos_file, 'w', encoding='utf-8') as f:
            json.dump(pos_data, f, ensure_ascii=False, indent=4)
    
    # 设置 posa 或 posb 数据
    def set_pos(self, player, pos_type: str):
        global blockposx,blockposy,blockposz
        pos_data = self.load_pos_data()
        location = player.location
        player_name = player.name

        if player_name not in pos_data:
            pos_data[player_name] = {
                "posa": {"x": None, "y": None, "z": None},
                "posb": {"x": None, "y": None, "z": None},
                "dim": None,
                "count": 0
            }

        # 更新相应的 posa 或 posb 数据
        if pos_type == "posa":
            pos_data[player_name]["posa"] = {
                "x": math.floor(blockposx),
                "y": math.floor(blockposy),
                "z": math.floor(blockposz)
            }
            pos_data[player_name]["dim"] = self.get_dimension_code(location.dimension.name)
            pos_data[player_name]["count"] = 1
            player.send_message(f"PosA 已保存为: x={blockposx}, y={blockposy}, z={blockposz}")
        elif pos_type == "posb":
            
            pos_data[player_name]["dim"] = self.get_dimension_code(location.dimension.name)
            pos_data[player_name]["count"] = 0
            player.send_message(f"PosB 已保存为: x={blockposx}, y={blockposy}, z={blockposz}")
            
            pos_data[player_name]["posb"]["x"] = blockposx
            pos_data[player_name]["posb"]["y"] = blockposy
            pos_data[player_name]["posb"]["z"] = blockposz
            self.save_pos_data(pos_data)
            posaxe=self.load_pos_data()[player.name]["posa"]["x"]
            posaye=self.load_pos_data()[player.name]["posa"]["y"]
            posaze=self.load_pos_data()[player.name]["posa"]["z"]
            posbxe=self.load_pos_data()[player.name]["posb"]["x"]
            posbye=self.load_pos_data()[player.name]["posb"]["y"]
            posbze=self.load_pos_data()[player.name]["posb"]["z"]
            #player.send_message(f"posa:({posaxe},{posaye},{posaze}) posb:({posbxe},{posbye},{posbze})")
            player.send_message(f"开始自动转换posa为小 posb为大")
            posaxn=self.load_pos_data()[player.name]["posa"]["x"]
            posayn=self.load_pos_data()[player.name]["posa"]["y"]
            posazn=self.load_pos_data()[player.name]["posa"]["z"]
            posbxn=self.load_pos_data()[player.name]["posb"]["x"]
            posbyn=self.load_pos_data()[player.name]["posb"]["y"]
            posbzn=self.load_pos_data()[player.name]["posb"]["z"]
            pos_data[player_name]["posa"] = {
                "x": int(min(posaxn,posbxn)),
                "y": int(min(posayn,posbyn)),
                "z": int(min(posazn,posbzn))
            }#######
            pos_data[player_name]["posb"] = {
                "x": int(max(posaxn,posbxn)),
                "y": int(max(posayn,posbyn)),
                "z": int(max(posazn,posbzn))
            }
            self.save_pos_data(pos_data)
            posaxe=self.load_pos_data()[player.name]["posa"]["x"]
            posaye=self.load_pos_data()[player.name]["posa"]["y"]
            posaze=self.load_pos_data()[player.name]["posa"]["z"]
            posbxe=self.load_pos_data()[player.name]["posb"]["x"]
            posbye=self.load_pos_data()[player.name]["posb"]["y"]
            posbze=self.load_pos_data()[player.name]["posb"]["z"]
            player.send_message(f"posa:({posaxe},{posaye},{posaze}) posb:({int(posbxe)},{int(posbye)},{int(posbze)})")
        # 保存数据
        self.save_pos_data(pos_data)

    # 获取维度编号
    def get_dimension_code(self, dimension_name):
        if dimension_name == "Overworld":
            return 0
        elif dimension_name == "Nether":
            return 1
        elif dimension_name == "TheEnd":
            return 2
        return -1

    # 填充区域
    def fill_area(self, sender: CommandSender, block_id: str):
        global runmode, coordinate_list, current_player
        
        player_name = sender.name
        pos_data = self.load_pos_data()

        if player_name not in pos_data:
            sender.send_message("请先设置 posa 和 posb 位置！")
            return

        posa = pos_data[player_name]["posa"]
        posb = pos_data[player_name]["posb"]
        dim = pos_data[player_name]["dim"]

        # 计算选区大小
        min_x = min(posa["x"], posb["x"])
        max_x = max(posa["x"], posb["x"])
        min_y = min(posa["y"], posb["y"])
        max_y = max(posa["y"], posb["y"])
        min_z = min(posa["z"], posb["z"])
        max_z = max(posb["z"], posb["z"])

        # 划分小选区
        coordinate_list = []
        for x in range(min_x, max_x + 1, 16):
            for z in range(min_z, max_z + 1, 16):
                coordinate_list.append((x, min_y, z, min(x + 15, max_x), max_y, min(z + 15, max_z)))
        
        current_player = sender
        runmode = 1
        sender.send_message(f"开始填充区域，共 {len(coordinate_list)} 个小选区！")

    # 定时任务：填充小选区
    def send_time(self) -> None:
        global runmode, coordinate_list, current_player, block_id,remode

        if runmode == 1 and remode==0 and current_player is not None:
            if coordinate_list:
                # 获取下一个小选区
                coord = coordinate_list.pop(0)
                min_x, min_y, min_z, max_x, max_y, max_z = coord

                # 执行填充操作
                tp_command = f"execute in {self.get_dimension_name()} run tp @s {min_x} ~ {min_z}"
                fill_command = f"fill {min_x} {min_y} {min_z} {max_x} {max_y} {max_z} {block_id}"
                #ta = f"tickingarea add {min_x} {min_y} {min_z} {max_x} {max_y} {max_z} worldbuilder true"
                current_player.perform_command(tp_command)
                #current_player.perform_command(ta)
                out=current_player.perform_command(fill_command)
                if out == True:
                #current_player.perform_command(ta)
                    current_player.send_message(f"已填充小选区: x={min_x}~{max_x}, z={min_z}~{max_z}")
                if out == False:
                    
                    global reminx,reminy,reminz,remaxx,remaxy,remaxz,tpcmd,fillcmd,replayername
                    replayername=current_player.name
                    remode=1
                    reminx=min_x
                    reminy=min_y
                    reminz=min_z
                    remaxx=max_x
                    remaxy=max_y
                    remaxz=max_z
                    tpcmd=tp_command
                    fillcmd=fill_command
                    self.server.scheduler.run_task(self, self.refill, period=20)
                    
                    
                    
            else:
                current_player.send_message("填充完成！")
                global ox,oy,oz
                current_player.perform_command(f"tp @s {ox} {oy} {oz}")
                runmode = 0

    # 定时任务：检测木斧右键的事件处理
    def send_time_a(self) -> None:
        global opencount, player_namea

        if opencount > 0:
            opencount -= 1  # 计数器减少
            if opencount == 1:
                # 当计数器等于 1 时，获取玩家并交替保存 posa 和 posb
                player = self.server.get_player(player_namea)
                pos_data = self.load_pos_data()

                if player_namea not in pos_data:
                    pos_data[player_namea] = {
                        "posa": {"x": None, "y": None, "z": None},
                        "posb": {"x": None, "y": None, "z": None},
                        "dim": None,
                        "count": 0
                    }

                # 切换 count 值并保存对应的 posa 或 posb 数据
                count = pos_data[player_namea]["count"]
                if count == 0:
                    self.set_pos(player, "posa")
                else:
                    self.set_pos(player, "posb")

    # 获取维度名称
    def get_dimension_name(self):
        if current_player:
            dimension_code = self.load_pos_data()[current_player.name]["dim"]
            if dimension_code == 0:
                return "overworld"
            elif dimension_code == 1:
                return "nether"
            elif dimension_code == 2:
                return "the_end"
        return "overworld"

    @event_handler
    def on_player_interact(self, event: PlayerInteractEvent):
        global opencount, player_namea ,blockposx,blockposy,blockposz
        player = event.player
        blockposx =event.block.location.x
        blockposy =event.block.location.y
        blockposz =event.block.location.z
        player_name = player.name
        player_namea = player_name  # 更新 global 变量 player_namea

        # 判断玩家是否手持木斧并右键方块
        if " " in player_name:
            player_name = f'"{player_name}"'
        if self.server.dispatch_command(self.server.command_sender, f"title @a[name={player_name},hasitem=[{{item=wooden_axe,location=slot.weapon.mainhand}}]] actionbar 设置坐标中"):
            opencount = 3  # 触发次数初始化

plugin = Ye111566Worldbuilder()
